library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;

entity led_drv is
    port (
        clk: in STD_LOGIC;
        stc_dav: in STD_LOGIC;
        gntn: in STD_LOGIC_VECTOR (3 downto 0);
        frame_n: in STD_LOGIC;
        led: out STD_LOGIC_VECTOR (4 downto 0)
    );
end led_drv;

architecture led_drv_arch of led_drv is
signal bc_master: std_logic;
signal u2_master: std_logic;
signal frame_dl: std_logic;
begin
led(0) <= '1';
led(1) <= '0' when bc_master = '1' else 'Z';
led(2) <= '1';
led(3) <= '0' when u2_master = '1' else 'Z';
led(4) <= '0';
--ledgen: for i in led'range generate
--  led(i) <= '0' when ledp(i) = '1' else 'Z';
--end generate ledgen;
  -- <<enter your statements here>>
process(clk)
begin
  if(clk'event and clk='1')then
    frame_dl <= frame_n;
    u2_master <= not frame_n and (u2_master or (not gntn(2) and frame_dl));
    bc_master <= not frame_n and (bc_master or (not gntn(3) and frame_dl));
  end if;
end process;
end led_drv_arch;
